

    if(argc < 3)
        print_help();

    for(i=1; i<argc; i++) {
        if(!argv[i])
            continue;
        if(argv[i][0] != '-') {
            if(!in_name) {
                in_name = argv[i];
                continue;
            } else
            if(!out_name) {
                out_name = argv[i];
                continue;
            } else {
                print_help();
            }
        }
        j=1;
        break_sw = 0;
        while(!break_sw &&
              (a = argv[i][j]) && (a != ' ') && (a != '\t')) {
            switch(a) {
            case 'b' :
                i++;
                if(!argv[i])
                    print_help();
                xscanf(argv[i], XT("%d"), &bs);
                if(!bs)
                    bs = 2048;
                break_sw = 1;
                break;
            case 'l' :
                i++;
                if(!argv[i])
                    print_help();
                log_name = argv[i];
                break_sw = 1;
                break;
            case 'S' :
                i++;
                if(!argv[i])
                    print_help();
                fill_string = argv[i];
                break_sw = 1;
                break;
            case 's':
                fill_string = XT("** BAD BLOCK **");
                break_sw = 1;
                break;
            case 'o' :
                a = argv[i][j+1];
                switch(a) {
                case 'b':
                    i++;
                    if(!argv[i])
                        print_help();
                    xscanf(argv[i], XT("%I64d"), &offs);
                    block_offs = TRUE;
                case 'k':
                    i++;
                    if(!argv[i])
                        print_help();
                    xscanf(argv[i], XT("%I64d"), &offs);
                    offs *= 1024;
                case 'm':
                    i++;
                    if(!argv[i])
                        print_help();
                    xscanf(argv[i], XT("%I64d"), &offs);
                    offs *= 1024*1024;
                default:
                    i++;
                    if(!argv[i])
                        print_help();
                    xscanf(argv[i], XT("%I64d"), &offs);
                }
                break_sw = 1;
                break;
            case 'c' :
                a = argv[i][j+1];
                switch(a) {
                case 'b':
                    i++;
                    if(!argv[i])
                        print_help();
                    xscanf(argv[i], XT("%I64d"), &counter);
                    block_counter = TRUE;
                case 'k':
                    i++;
                    if(!argv[i])
                        print_help();
                    xscanf(argv[i], XT("%I64d"), &counter);
                    counter *= 1024;
                case 'm':
                    i++;
                    if(!argv[i])
                        print_help();
                    xscanf(argv[i], XT("%I64d"), &counter);
                    counter *= 1024*1024;
                default:
                    i++;
                    if(!argv[i])
                        print_help();
                    xscanf(argv[i], XT("%I64d"), &counter);
                }
                break_sw = 1;
                break;
            case 'r' :
                i++;
                if(!argv[i])
                    print_help();
                xscanf(argv[i], XT("%d"), &retry);
                break_sw = 1;
                break;
            case '?' :
            default:
                print_help();
            }
            j++;
        }
    }

    if(!in_name || !out_name)
        print_help();

    in_h = CreateFileX(in_name, GENERIC_READ, FILE_SHARE_READ, NULL,
                      OPEN_EXISTING,
                      FILE_ATTRIBUTE_NORMAL /*| FILE_FLAG_NO_BUFFERING*/ | FILE_FLAG_SEQUENTIAL_SCAN,
                      NULL);
    if(in_h == (HANDLE)(-1)) {
        xprintf(XT("Can't open source file %s\n")
               XT("exiting...\n"), in_name);
        read_bytes = GetLastError();
        exit (-1);
    }

    out_h = CreateFileX(out_name, GENERIC_READ | GENERIC_WRITE, FILE_SHARE_READ,
                      NULL,
                      OPEN_EXISTING,
                      FILE_ATTRIBUTE_NORMAL /*| FILE_FLAG_NO_BUFFERING*//* | FILE_FLAG_SEQUENTIAL_SCAN*/,
                      NULL);
    if(out_h == (HANDLE)(-1)) {
        new_target = TRUE;
        out_h = CreateFileX(out_name, GENERIC_READ | GENERIC_WRITE, FILE_SHARE_READ,
                          NULL,
                          OPEN_ALWAYS,
                          FILE_ATTRIBUTE_NORMAL /*| FILE_FLAG_NO_BUFFERING*//* | FILE_FLAG_SEQUENTIAL_SCAN*/,
                          NULL);
        if(out_h == (HANDLE)(-1)) {
            read_bytes = GetLastError();
            xprintf(XT("Can't open or create target file %s\n")
                   XT("exiting...\n"), out_name);
            exit (-3);
        }
    }

    if(log_name) {
        log_h = CreateFileX(log_name, GENERIC_READ | GENERIC_WRITE, FILE_SHARE_READ,
                          NULL,
                          CREATE_ALWAYS,
                          FILE_ATTRIBUTE_NORMAL /*| FILE_FLAG_NO_BUFFERING*//* | FILE_FLAG_SEQUENTIAL_SCAN*/,
                          NULL);
        if(log_h == (HANDLE)(-1)) {
            read_bytes = GetLastError();
            xprintf(XT("Can't create log file %s\n")
                   XT("exiting...\n"), log_name);
            exit (-6);
        }
    }
